/************************** (C) COPYRIGHT 2021  *****************
* File Name       : 
* Author            : 
* Version          : Ver 0.1
* Date               : 2021/10/26
* Description    : 
*
* Revision History
* Date          Version       Name          					Description
* 2021/10/06  	0.1          Oanny        					Proto.
*******************************************************************************/
#include "usr_system.h"
#include "usr_timer.h"

#include "nrf_drv_timer.h"
#include "nrf_gpio.h"

uint32_t Tick_Cnt = 0;
static const nrf_drv_timer_t m_timer = NRF_DRV_TIMER_INSTANCE(0);
/*******************************************************************************
* Function Name : 
* Parameters    : None
* Return        : None
* Description   : 
*******************************************************************************/
void timer_handler(nrf_timer_event_t event_type, void* p_context)
{
	GPIO_ToggleBit(LED_01);
	Tick_Cnt++;
}

/*******************************************************************************
* Function Name : 
* Parameters    : None
* Return        : None
* Description   : 
*******************************************************************************/
void timer_init(void)
{
	uint32_t err_code = NRF_SUCCESS;
	uint32_t time_ms = 1; //Time(in miliseconds) between consecutive compare events.
	uint32_t time_ticks;
	
	//Configure TIMER_LED for generating simple light effect - leds on board will invert his state one after the other.
	nrf_drv_timer_config_t timer_cfg = NRF_DRV_TIMER_DEFAULT_CONFIG;
	timer_cfg.bit_width = NRF_TIMER_BIT_WIDTH_32;
	err_code = nrf_drv_timer_init(&m_timer, &timer_cfg, timer_handler);
	APP_ERROR_CHECK(err_code);
	/* setup m_timer for compare event every 500ms */
	uint32_t ticks = nrf_drv_timer_ms_to_ticks(&m_timer, time_ms);

	nrf_drv_timer_extended_compare(&m_timer,
																 NRF_TIMER_CC_CHANNEL0,
																 ticks,
																 NRF_TIMER_SHORT_COMPARE0_CLEAR_MASK,
																 true);	
	nrf_drv_timer_enable(&m_timer);	
}